Botan: Botan::Twofish Class Reference

Botan 1.10.16

Public Types | Public Member Functions | List of all members
Botan::Twofish Class Reference

`#include <twofish.h>`

Inheritance diagram for Botan::Twofish:

## Public Types
enum |

## Public Member Functions
size_t | block_size () const
void | clear ()
BlockCipher * | clone () const
void | decrypt (const byte in[], byte out[]) const
void | decrypt (byte block[]) const
void | decrypt_n (const byte in[], byte out[], size_t blocks) const
void | encrypt (const byte in[], byte out[]) const
void | encrypt (byte block[]) const
void | encrypt_n (const byte in[], byte out[], size_t blocks) const
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
size_t | parallel_bytes () const
virtual size_t | parallelism () const
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
| Twofish ()
bool | valid_keylength (size_t length) const

## Detailed Description

Twofish, an AES finalist

Definition at line 18 of file twofish.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| inherited

Definition at line 107 of file block_cipher.h.

107 { BLOCK_SIZE = BS };
Botan::Block_Cipher_Fixed_Params< 16, 16, 32, 8 >::BLOCK_SIZE
Definition: block_cipher.h:107

## Constructor & Destructor Documentation

## ◆ Twofish()

Botan::Twofish::Twofish | ( |  | ) |
| inline

Definition at line 28 of file twofish.h.

28 : SB(1024), RK(40) {}

## Member Function Documentation

## ◆ block_size()

size_t Botan::Block_Cipher_Fixed_Params< BS, KMIN, KMAX, KMOD >::block_size | ( |  | ) | const
| inlinevirtualinherited

Returns
  block size of this algorithm

Implements Botan::BlockCipher.

Definition at line 108 of file block_cipher.h.

108 { return BS; }

## ◆ clear()

void Botan::Twofish::clear | ( |  | ) |
| virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 236 of file twofish.cpp.

References Botan::zeroise().

237 {
238 zeroise(SB);
239 zeroise(RK);
240 }
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:415

## ◆ clone()

BlockCipher* Botan::Twofish::clone | ( |  | ) | const
| inlinevirtual

Get a new object representing the same algorithm as *this

Implements Botan::BlockCipher.

Definition at line 26 of file twofish.h.

26 { return new Twofish; }
Botan::Twofish::Twofish
Twofish()
Definition: twofish.h:28

## ◆ decrypt() [1/2]

void Botan::BlockCipher::decrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inlineinherited

Decrypt a block.

Parameters

  in | The ciphertext block to be decypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the decrypted block. Must be of length block_size().

Definition at line 57 of file block_cipher.h.

Referenced by Botan::DESX::decrypt_n(), Botan::ECB_Decryption::name(), Botan::CTS_Decryption::set_iv(), and Botan::CBC_Decryption::set_iv().

58 { decrypt_n(in, out, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt() [2/2]

void Botan::BlockCipher::decrypt | ( | byte | block[] | ) | const
| inlineinherited

Decrypt a block.

Parameters

  block | the ciphertext block to be decrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 74 of file block_cipher.h.

74 { decrypt_n(block, block, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt_n()

void Botan::Twofish::decrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Decrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 71 of file twofish.cpp.

References Botan::Block_Cipher_Fixed_Params< 16, 16, 32, 8 >::BLOCK_SIZE, Botan::get_byte(), Botan::load_le< u32bit >(), Botan::rotate_left(), Botan::rotate_right(), and Botan::store_le().

72 {
73 for(size_t i = 0; i != blocks; ++i)
74 {
75 u32bit A = load_le<u32bit>(in, 0) ^ RK[4];
76 u32bit B = load_le<u32bit>(in, 1) ^ RK[5];
77 u32bit C = load_le<u32bit>(in, 2) ^ RK[6];
78 u32bit D = load_le<u32bit>(in, 3) ^ RK[7];
79
80 for(size_t j = 0; j != 16; j += 2)
81 {
82 u32bit X, Y;
83
84 X = SB[ get_byte(3, A)] ^ SB[256+get_byte(2, A)] ^
85 SB[512+get_byte(1, A)] ^ SB[768+get_byte(0, A)];
86 Y = SB[ get_byte(0, B)] ^ SB[256+get_byte(3, B)] ^
87 SB[512+get_byte(2, B)] ^ SB[768+get_byte(1, B)];
88 X += Y;
89 Y += X + RK[39 - 2*j];
90 X += RK[38 - 2*j];
91
92 C = rotate_left(C, 1) ^ X;
93 D = rotate_right(D ^ Y, 1);
94
95 X = SB[ get_byte(3, C)] ^ SB[256+get_byte(2, C)] ^
96 SB[512+get_byte(1, C)] ^ SB[768+get_byte(0, C)];
97 Y = SB[ get_byte(0, D)] ^ SB[256+get_byte(3, D)] ^
98 SB[512+get_byte(2, D)] ^ SB[768+get_byte(1, D)];
99 X += Y;
100 Y += X + RK[37 - 2*j];
101 X += RK[36 - 2*j];
102
103 A = rotate_left(A, 1) ^ X;
104 B = rotate_right(B ^ Y, 1);
105 }
106
107 C ^= RK[0];
108 D ^= RK[1];
109 A ^= RK[2];
110 B ^= RK[3];
111
112 store_le(out, C, D, A, B);
113
114 in += BLOCK_SIZE;
115 out += BLOCK_SIZE;
116 }
117 }
Botan::Block_Cipher_Fixed_Params< 16, 16, 32, 8 >::BLOCK_SIZE
Definition: block_cipher.h:107
Botan::store_le
void store_le(u16bit in, byte out[2])
Definition: loadstor.h:427
Botan::rotate_left
T rotate_left(T input, size_t rot)
Definition: rotate.h:21
Botan::get_byte
byte get_byte(size_t byte_num, T input)
Definition: get_byte.h:21
Botan::rotate_right
T rotate_right(T input, size_t rot)
Definition: rotate.h:34
Botan::load_le< u32bit >
u32bit load_le< u32bit >(const byte in[], size_t off)
Definition: loadstor.h:183
Botan::u32bit
unsigned int u32bit
Definition: types.h:32

## ◆ encrypt() [1/2]

void Botan::BlockCipher::encrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inlineinherited

Encrypt a block.

Parameters

  in | The plaintext block to be encrypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the encrypted block. Must be of length block_size().

Definition at line 47 of file block_cipher.h.

Referenced by Botan::aont_unpackage(), Botan::OFB::cipher(), Botan::DESX::encrypt_n(), Botan::CMAC::poly_double(), Botan::ANSI_X931_RNG::randomize(), Botan::Randpool::randomize(), Botan::OFB::set_iv(), Botan::CTS_Encryption::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::XTS_Encryption::set_iv(), Botan::CBC_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), and Botan::XTS_Decryption::set_iv().

48 { encrypt_n(in, out, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt() [2/2]

void Botan::BlockCipher::encrypt | ( | byte | block[] | ) | const
| inlineinherited

Encrypt a block.

Parameters

  block | the plaintext block to be encrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 66 of file block_cipher.h.

66 { encrypt_n(block, block, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt_n()

void Botan::Twofish::encrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Encrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 20 of file twofish.cpp.

References Botan::Block_Cipher_Fixed_Params< 16, 16, 32, 8 >::BLOCK_SIZE, Botan::get_byte(), Botan::load_le< u32bit >(), Botan::rotate_left(), Botan::rotate_right(), and Botan::store_le().

21 {
22 for(size_t i = 0; i != blocks; ++i)
23 {
24 u32bit A = load_le<u32bit>(in, 0) ^ RK[0];
25 u32bit B = load_le<u32bit>(in, 1) ^ RK[1];
26 u32bit C = load_le<u32bit>(in, 2) ^ RK[2];
27 u32bit D = load_le<u32bit>(in, 3) ^ RK[3];
28
29 for(size_t j = 0; j != 16; j += 2)
30 {
31 u32bit X, Y;
32
33 X = SB[ get_byte(3, A)] ^ SB[256+get_byte(2, A)] ^
34 SB[512+get_byte(1, A)] ^ SB[768+get_byte(0, A)];
35 Y = SB[ get_byte(0, B)] ^ SB[256+get_byte(3, B)] ^
36 SB[512+get_byte(2, B)] ^ SB[768+get_byte(1, B)];
37 X += Y;
38 Y += X + RK[2*j + 9];
39 X += RK[2*j + 8];
40
41 C = rotate_right(C ^ X, 1);
42 D = rotate_left(D, 1) ^ Y;
43
44 X = SB[ get_byte(3, C)] ^ SB[256+get_byte(2, C)] ^
45 SB[512+get_byte(1, C)] ^ SB[768+get_byte(0, C)];
46 Y = SB[ get_byte(0, D)] ^ SB[256+get_byte(3, D)] ^
47 SB[512+get_byte(2, D)] ^ SB[768+get_byte(1, D)];
48 X += Y;
49 Y += X + RK[2*j + 11];
50 X += RK[2*j + 10];
51
52 A = rotate_right(A ^ X, 1);
53 B = rotate_left(B, 1) ^ Y;
54 }
55
56 C ^= RK[4];
57 D ^= RK[5];
58 A ^= RK[6];
59 B ^= RK[7];
60
61 store_le(out, C, D, A, B);
62
63 in += BLOCK_SIZE;
64 out += BLOCK_SIZE;
65 }
66 }
Botan::Block_Cipher_Fixed_Params< 16, 16, 32, 8 >::BLOCK_SIZE
Definition: block_cipher.h:107
Botan::store_le
void store_le(u16bit in, byte out[2])
Definition: loadstor.h:427
Botan::rotate_left
T rotate_left(T input, size_t rot)
Definition: rotate.h:21
Botan::get_byte
byte get_byte(size_t byte_num, T input)
Definition: get_byte.h:21
Botan::rotate_right
T rotate_right(T input, size_t rot)
Definition: rotate.h:34
Botan::load_le< u32bit >
u32bit load_le< u32bit >(const byte in[], size_t off)
Definition: loadstor.h:183
Botan::u32bit
unsigned int u32bit
Definition: types.h:32

## ◆ key_spec()

Key_Length_Specification Botan::Block_Cipher_Fixed_Params< BS, KMIN, KMAX, KMOD >::key_spec | ( |  | ) | const
| inlinevirtualinherited

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 110 of file block_cipher.h.

111 {
112 return Key_Length_Specification(KMIN, KMAX, KMOD);
113 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inlineinherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

Referenced by Botan::Cascade_Cipher::decrypt_n(), and Botan::ANSI_X931_RNG::randomize().

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inlineinherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::Twofish::name | ( |  | ) | const
| inlinevirtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 25 of file twofish.h.

25 { return "Twofish"; }

## ◆ parallel_bytes()

size_t Botan::BlockCipher::parallel_bytes | ( |  | ) | const
| inlineinherited

Returns
  prefererred parallelism of this cipher in bytes

Definition at line 35 of file block_cipher.h.

36 {
37 return parallelism() * block_size() * BOTAN_BLOCK_CIPHER_PAR_MULT;
38 }
Botan::BlockCipher::parallelism
virtual size_t parallelism() const
Definition: block_cipher.h:30
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

## ◆ parallelism()

virtual size_t Botan::BlockCipher::parallelism | ( |  | ) | const
| inlinevirtualinherited

Returns
  native parallelism of this cipher in blocks

Reimplemented in Botan::AES_256_NI, Botan::AES_192_NI, Botan::AES_128_NI, Botan::IDEA_SSE2, Botan::Noekeon_SIMD, Botan::Serpent_SIMD, and Botan::XTEA_SIMD.

Definition at line 30 of file block_cipher.h.

30 { return 1; }

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::CTR_BE::clear(), Botan::OFB::clear(), Botan::DESX::decrypt_n(), Botan::Cascade_Cipher::decrypt_n(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::ANSI_X931_RNG::randomize(), Botan::Randpool::randomize(), Botan::HMAC_RNG::reseed(), Botan::XTS_Encryption::set_key(), Botan::EAX_Base::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), Botan::StreamCipher_Filter::StreamCipher_Filter(), Botan::DLIES_Decryptor::~DLIES_Decryptor(), and Botan::DLIES_Encryptor::~DLIES_Encryptor().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inlineinherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), Botan::Lion::Lion(), and Botan::Randpool::Randpool().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/block/twofish/twofish.h
- src/block/twofish/two_tab.cpp
- src/block/twofish/twofish.cpp